
(function () {
    var DEBUGGER_SHOW_ON_VISIBLE_KEY = "dorado.Debugger.showOnVisible";
    function setCookie(name, value, expire) {
        var exp = new Date();
        exp.setTime(exp.getTime() + expire);
        document.cookie = name + "=" + escape(value) + ";expires=" + exp.toGMTString();
    }
    function getCookie(name) {
        var arr = document.cookie.match(new RegExp("(^| )" + name + "=([^;]*)(;|$)"));
        if (arr != null) {
            return unescape(arr[2]);
        }
        return null;
    }
    function delCookie(name) {
        var exp = new Date();
        exp.setTime(exp.getTime() - 1);
        var cval = getCookie(name);
        if (cval != null) {
            document.cookie = name + "=" + cval + ";expires=" + exp.toGMTString();
        }
    }
    dorado.debug = {};
    dorado.Debugger = {inited:false, initTabs:[], moduleActiveEvent:{}, trapError:true, format2HTML:function (text) {
        var reg1 = new RegExp("&", "g"), pattern = new RegExp("[<>\"\n\t]", "g"), map = {"<":"&lt;", ">":"&gt;", "\n":"<br/>", "\t":"&nbsp;&nbsp;", "\"":"&quot;"};
        return text.replace(reg1, "&amp;").replace(pattern, function (string) {
            return map[string];
        });
    }, init:function () {
        var tabControl = new dorado.widget.TabControl({$type:"TabControl", tabs:dorado.Debugger.initTabs, onTabChange:function (self, arg) {
            var tab = arg.tab;
            if (tab && tab._name) {
                var callback = dorado.Debugger.moduleActiveEvent[tab._name];
                if (callback) {
                    callback.apply(this, arguments);
                }
            }
        }});
        var dialog = new dorado.widget.Dialog({layout:{$type:"Dock", padding:1}, caption:"Dorado Debugger", width:800, height:500, dragOutside:true, center:true, maximizeable:true, exClassName:"d-debugger", contentOverflow:"hidden", children:[tabControl, {$type:"Container", layout:{$type:"Dock", padding:4}, layoutConstraint:"bottom", height:30, children:[{$type:"CheckBox", caption:"Visible on load", checked:!!getCookie(DEBUGGER_SHOW_ON_VISIBLE_KEY), listener:{onValueChange:function (self) {
            if (self._value) {
                setCookie(DEBUGGER_SHOW_ON_VISIBLE_KEY, true, 3600 * 24 * 365 * 1000);
            } else {
                delCookie(DEBUGGER_SHOW_ON_VISIBLE_KEY);
            }
        }}}]}]});
        this.tabControl = tabControl;
        this.dialog = dialog;
        this.inited = true;
    }, extend:function (source) {
        for (var prop in source) {
            dorado.Debugger[prop] = source[prop];
        }
    }, registerModule:function (config) {
        var deb = dorado.Debugger;
        config = config || {};
        if (config.name && config.onActive) {
            deb.moduleActiveEvent[config.name] = config.onActive;
        }
        if (!deb.inited) {
            deb.initTabs.push(config);
        } else {
            this.tabControl.insertTab(config);
        }
    }, show:function () {
        var deb = dorado.Debugger;
        if (!deb.inited) {
            deb.init();
        }
        deb.dialog.show();
    }};
    $(document).ready(function () {
        var showOnVisible = getCookie(DEBUGGER_SHOW_ON_VISIBLE_KEY);
        if (showOnVisible) {
            dorado.Debugger.show();
        }
        jQuery(document).bind("keydown", "f2", function () {
            dorado.Debugger.show();
        });
        jQuery(document).bind("keydown", "ctrl+f12", function () {
            dorado.Debugger.show();
        });
    });
    window.$log = dorado.Debugger.log;
})();

